﻿// Copyright (C) 2016 SRG Technology, LLC
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

using System;
using System.Web;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.Reflection;
using System.Runtime.CompilerServices;
using System.Drawing;

using HomeSeerAPI;

namespace HSPI_AKTemplate
{
    using HSDevice = Scheduler.Classes.DeviceClass;
    using DeviceDictHS = Dictionary<int, Scheduler.Classes.DeviceClass>;

    /// <summary>
    ///     Base class for HSPI plugin.
    ///     <para />
    ///     A new class with the name HSPI should be derived from this base class.
    ///     <list type="number">
    ///         <item>
    ///             <description>The namespace of the new class must be the same as the EXE filename (without extension).</description>
    ///         </item>
    ///         <item>
    ///             <description>This new class must be public, named HSPI, and be in the root of the namespace.</description>
    ///         </item>
    ///     </list>
    ///     <para />
    ///     Adapted from C# sample generated by Marcus Szolkowski.
    ///     See thread "Really simple C# sample plugin available here!" http://board.HomeSeer.com/showthread.php?t=178122.
    /// </summary>
    /// <seealso cref="IPlugInAPI" />
    public abstract partial class HspiBase2 : HspiBase
    {
        public ControllerBase controller { get; protected set; }

        public DeviceDictHS Devices { get { return controller.devices; } }



        public override IPlugInAPI.strInterfaceStatus InterfaceStatus()
        {
            var s = new IPlugInAPI.strInterfaceStatus {intStatus = IPlugInAPI.enumInterfaceStatus.OK};
            return s;
        }

        public override string InstanceFriendlyName()
        {
            return string.Empty;
        }

        public override int Capabilities()
        {
            return (int) Enums.eCapabilities.CA_IO;
        }

        public override int AccessLevel()
        {
            return 2;
        }

        protected override bool GetHscomPort()
        {
            return false;
        }

        public override bool SupportsAddDevice()
        {
            return false;
        }

        public override bool SupportsConfigDevice()
        {
            return false;
        }

        public override bool SupportsConfigDeviceAll()
        {
            return false;
        }

        public override bool SupportsMultipleInstances()
        {
            return false;
        }

        public override bool SupportsMultipleInstancesSingleEXE()
        {
            return false;
        }

        public override bool RaisesGenericCallbacks()
        {
            return false;
        }

        /// <summary>
        /// When you wish to have HomeSeer call back in to your plug-in or application when certain events happen in the system,
        /// call the RegisterEventCB procedure and provide it with event you wish to monitor. 
        /// See RegisterEventCB for more information and an example and event types.
        /// </summary>
        public override void HSEvent(Enums.HSEvent eventType, object[] parameters)
        {
            if (eventType == Enums.HSEvent.VALUE_CHANGE)
            {
                // For HSEvent.VALUE_CHANGE:
                // 0. eventType
                // 1. The device's address (string)
                // 2. The new value of the device (double)
                // 3. The old value of the device (double)
                // 4. The device's reference number (integer)

                // for performace inspect only devices in MonitoredDevices list
                // as they are registered as "Linked Status Device"
                int devID = (int)parameters[4];
                if (controller.DeviceUsed(devID))
                {
                    controller.ValueChanged(parameters: parameters);
                }
            }

            if (eventType == Enums.HSEvent.CONFIG_CHANGE)
            {
                // For HSEvent.CONFIG_CHANGE:
                // 0. eventType
                // 1. Type: 0=a device was changed 1=an event was changed 2=an event group was changed
                // 2. deprecated
                // 3. The device/event/event group reference number. 0 means that the reference is not known.
                // 4. DAC device/event was 0 = not known, 1 = Added, 2 = Deleted, 3 = Changed
                // 5. A string describing what changed
                // So if a used device was deleted:
                if ((int)parameters[1] == 0 && (int)parameters[4] == 2)
                {
                    int devID = (int)parameters[3];
                    if (controller.DeviceUsed(devID))
                    {
                        controller.DeviceDeleted(devID);
                    }
                }
            }
        }

        /// <summary>
        /// SetIOMulti is called by HomeSeer when a device that your plugin owns is controlled.  
        /// Your plugin owns a device when it's INTERFACE property is set to the name of your plugin.
        /// </summary>
        /// <param name="colSend">
        /// This is a collection of CAPIControl objects, one object for each device that needs to be controlled. 
        /// Look at the ControlValue property to get the value that device needs to be set to.
        /// </param>
        public override void SetIOMulti(List<CAPI.CAPIControl> colSend)
        {
            //Multiple CAPIcontrols might be sent at the same time, so we need to check each one
            foreach (CAPI.CAPIControl cc in colSend)
            {
                // This is called for devices registered for this plugin
                // before the value is actually modified inside HS - it's more like a change request
                // So for confirmation must set HS.SetDeviceValueByRef()
                // But don't need to process any further as HS will call HSEvent after that anyway
                controller.ValueChanged(cc);
            }
        }

        //public override void HSEvent(Enums.HSEvent eventType, object[] parameters)
        //{
        //}

        //public override void SetIOMulti(List<CAPI.CAPIControl> colSend)
        //{
        //    // HomeSeer will inform us when the one of our devices has changed.  Push that change through to the field.
        //}

        public override string InitIO(string port)
        {
            AppDomain currentDomain = AppDomain.CurrentDomain;
            //currentDomain.AssemblyResolve += new ResolveEventHandler(Utils.LoadFromSameFolder);
            currentDomain.UnhandledException += new UnhandledExceptionEventHandler(UnhandledExceptionHandler);

            // let our console wrapper know we recived InitIO request from HS
            InitIOEvent.Set();
            return "";
        }



        public override IPlugInAPI.PollResultInfo PollDevice(int deviceId)
        {
            var pollResult = new IPlugInAPI.PollResultInfo
            {
                Result = IPlugInAPI.enumPollResult.Device_Not_Found,
                Value = 0
            };

            return pollResult;
        }


        public override void ShutdownIO()
        {
            // let our console wrapper know we are finished
            Shutdown = true;
            ShutdownEvent.Set();
        }

        public override SearchReturn[] Search(string searchString, bool regEx)
        {
            return null;
        }

        public override void SpeakIn(int deviceId, string text, bool wait, string host)
        {
        }

        #region Web Interface


        /// <summary>
        /// This function is available for the ease of converting older HS2 plugins,
        /// however, it is desirable to use the new clsPageBuilder class for all new development.
        /// This function is called by HomeSeer from the form or class object that a web page was registered with using RegisterConfigLink.
        /// You must have a GenPage procedure per web page that you register with HomeSeer.
        /// This page is called when the user requests the web page with an HTTP Get command,
        /// which is the default operation when the browser requests a page.
        /// </summary>
        public override string GenPage(string link)
        {
            // GenPage is called if RegisterWebPage doesn't call RegisterPage
            // Difference with GetPagePlugin - GenPage add standard header/footer, 
            // but GetPagePlugin expects full page including header/footer
            return GetPagePlugin(link, null, -1, null);
        }

        /// <summary>
        /// When your plugin web page has form elements on it, and the form is submitted,
        /// this procedure is called to handle the HTTP "Put" request.
        /// There must be one PagePut procedure in each plugin object or
        /// class that is registered as a web page in HomeSeer.
        /// </summary>
        public override string PagePut(string data)
        {
            return "PagePut: '" + data + "'";
        }


        /// <summary>
        /// A complete page needs to be created and returned.
        /// Web pages that use the clsPageBuilder class and registered with
        /// HS.RegisterLink and HS.RegisterConfigLink will then be called through this function. 
        /// Also for GetPagePlugin to be called - must call RegisterPage()
        /// </summary>
        /// <param name="page">The name of the page as passed to the HS.RegisterLink function.</param>
        /// <param name="user">The name of logged in user.</param>
        /// <param name="userRights">The rights of the logged in user.</param>
        /// <param name="queryString">The query string.</param>
        public override string GetPagePlugin(string page, string user, int userRights, string queryString)
        {
            return PageBuilder.GetPagePlugin(page, user, userRights, queryString);
        }


        public override string PostBackProc(string page, string data, string user, int userRights)

        {
            return PageBuilder.PostBackProc(page, data, user, userRights);
        }


        /// <summary>
        /// If SupportsConfigDevice returns <c>true</c>, this function will be called when the device properties are displayed for your device.
        /// The device properties is displayed from the Device Utility page.
        /// This page displays a tab for each plugin that controls the device.
        /// Normally, only one plugin will be associated with a single device.
        /// If there is any configuration that needs to be set on the device, you can return any HTML that you would like displayed.
        /// Normally this would be any jquery controls that allow customization of the device.
        /// The returned HTML is just an HTML fragment and not a complete page.
        /// </summary>
        /// <param name="ref">The device reference id.</param>
        /// <param name="user">The name of logged in user.</param>
        /// <param name="userRights">The rights of the logged in user.</param>
        /// <param name="newDevice"><c>True</c> if this is a new device being created for the first time.
        /// In this case, the device configuration dialog may present different information than when simply editing an existing device.</param>
        /// <returns>A string containing HTML to be displayed. Return an empty string if there is not configuration needed.</returns>
        public override string ConfigDevice(int deviceId, string user, int userRights, bool newDevice)
        {
            return controller.ConfigDevice(deviceId); ;
        }


        /// <summary>
        /// Called when a user posts information from your plugin tab on the device utility page. 
        /// </summary>
        /// <param name="ref">The device reference id.</param>
        /// <param name="data">The post data.</param>
        /// <param name="user">The name of logged in user.</param>
        /// <param name="userRights">The rights of the logged in user.</param>
        /// <returns>Enums.ConfigDevicePostReturn.</returns>
        public override Enums.ConfigDevicePostReturn ConfigDevicePost(int deviceId, string data, string user, int userRights)
        {
            NameValueCollection parts = HttpUtility.ParseQueryString(data);
            return controller.ConfigDevicePost(deviceId, parts);
        }

        #endregion Web Interface



        /// <summary>
        /// There may be times when you need to offer a custom function that is not part of the plugin API. 
        /// The API functions allow users to call your plugin from scripts and web pages by calling the functions by name.
        /// </summary>
        /// <returns>The property get.</returns>
        /// <param name="procedureName">Procedure name.</param>
        /// <param name="parameters">parameters.</param>
        public override object PluginFunction(string functionName, object[] parameters)
        {
            try
            {
                MethodInfo method = this.GetType().GetMethod(functionName);
                if ((object)method != null)
                    return method.Invoke(this, parameters);
                Utils.Log("Method " + functionName + " does not exist in this plugin.", Utils.LogType.Error);
                return null;
            }
            catch (Exception ex)
            {
                Utils.Log("Error in PluginProc: " + ex.Message, Utils.LogType.Error);
            }
            return null;
        }

        /// <summary>
        /// There may be times when you need to offer a custom function that is not part of the plugin API. 
        /// The API functions allow users to call your plugin from scripts and web pages by calling the functions by name.
        /// </summary>
        /// <returns>The property get.</returns>
        /// <param name="procedureName">Procedure name.</param>
        /// <param name="parameters">parameters.</param>
        public override object PluginPropertyGet(string propertyName, object[] parameters)
        {
            try
            {
                PropertyInfo property = this.GetType().GetProperty(propertyName);
                if ((object)property != null)
                    return property.GetValue(this, parameters);

                Utils.Log("Property " + propertyName + " does not exist in this plugin.", Utils.LogType.Error);
            }
            catch (Exception ex)
            {
                Utils.Log("Error in PluginPropertyGet: " + ex.Message, Utils.LogType.Error);
            }
            return null;
        }

        /// <summary>
        /// There may be times when you need to offer a custom function that is not part of the plugin API. 
        /// The API functions allow users to call your plugin from scripts and web pages by calling the functions by name.
        /// </summary>
        /// <returns>The property get.</returns>
        /// <param name="procedureName">Procedure name.</param>
        /// <param name="parameters">parameters.</param>
        public override void PluginPropertySet(string propertyName, object value)
        {
            try
            {
                PropertyInfo property = this.GetType().GetProperty(propertyName);
                if (property == null)
                    Utils.Log("Property " + propertyName + " does not exist in this plugin.", Utils.LogType.Error);

                property.SetValue(this, RuntimeHelpers.GetObjectValue(value), null);
            }
            catch (Exception ex)
            {
                Utils.Log("Error in PluginPropertySet: " + ex.Message, Utils.LogType.Error);
            }
        }

        //public override void SetDeviceValue(int deviceId, double value, bool trigger = true)
        //{
        //    HS.SetDeviceValueByRef(deviceId, value, trigger);
        //}

        #region RegisterWebPage

        public enum PageType
        {
            Menu,
            Config,
            Both,
            Help
        }

        /// <summary>
        /// Registers the web page in HomeSeer
        /// </summary>
        /// <param name="linktext"></param>
        /// <param name="link"></param>
        /// <param name="page_title"></param>
        /// <param name="type">PageType</param>
        /// <returns></returns>
        public string RegisterWebPage(string linktext, string link = "", string page_title = "", PageType type = PageType.Both)
        {
            if (String.IsNullOrEmpty(link))
            {
                link = linktext;
            }

            if (String.IsNullOrEmpty(page_title))
                page_title = linktext;

            // Make link unique by pre-peending plugin name
            link = MakePageLink(link);

            //string s1 = HS.RegisterPage(linktext + "", Name, ""); //??
            string s2 = HS.RegisterPage(link + "", Name, "");     //??

            WebPageDesc wpd = new WebPageDesc();
            wpd.link = link + "";
            wpd.linktext = linktext;
            wpd.page_title = page_title;
            wpd.plugInName = Name;
            wpd.plugInInstance = "";

            switch(type)
            {
                case PageType.Config:
                    // register a configuration link that will appear on the interfaces page
                    Callback.RegisterConfigLink(wpd);
                    break;

                case PageType.Menu:
                    // register a normal page to appear in the HomeSeer menu
                    Callback.RegisterLink(wpd);
                    break;

                case PageType.Both:
                    // register a configuration link that will appear on the interfaces page
                    Callback.RegisterConfigLink(wpd);
                    // register a normal page to appear in the HomeSeer menu
                    Callback.RegisterLink(wpd);
                    break;

                case PageType.Help:
                    HS.RegisterHelpLink(wpd);
                    break;
                }

            // This link HS will pass to GetPagePlugin
            return link;
        }



        public string IniFile
        {
            get
            {
                return PluginNameNoSpace + ".ini";
            }
        }

        public string PluginNameNoSpace
        {
            get
            {
                return PluginNameCleaned.Replace(" ", "");
            }
        }

        /// <summary>
        /// RegisterLink doesn't like these in page link title for some reason
        /// </summary>
        public string PluginNameCleaned
        {
            get
            {
                return clean(Name);
            }
        }

        public static string clean(string name)
        {
            if (name != null)
            {
                char[] bad = System.IO.Path.GetInvalidFileNameChars();
                //string bad = "(){}[]@#$%&!?*";
                for (int i = 0; i < bad.Length; i++)
                    name = name.Replace(bad[i].ToString(), "");
            }
            return name;
        }

        /// <summary>
        /// Create unique PageName by prepending plugin Name
        /// Except for "deviceutility" page
        /// </summary>
        /// <param name="pageName"></param>
        /// <returns></returns>
        public string MakePageLink(string pageName)
        {
            pageName = pageName.Replace(" ", "_");

            if (pageName == PageBuilder.DEVICEUTILITY || pageName.StartsWith(PluginNameNoSpace))
                return pageName;

            return PluginNameNoSpace + "_" + pageName;
        }

        #endregion RegisterWebPage


        #region Helpers


        void UnhandledExceptionHandler(object sender, UnhandledExceptionEventArgs args)
        {
            Exception ex = (Exception)args.ExceptionObject;
            Utils.Log("UnhandledException!!!", Utils.LogType.Error);
            Utils.Log(ex.Message, Utils.LogType.Error);
            Utils.Log(ex.ToString().Replace(" at ", "<BR>at: "), Utils.LogType.Error);
            Console.WriteLine("UnhandledException:" + ex.Message);
            Console.WriteLine(ex.ToString());
        }


        /// <summary>
        /// Send Image to html/images
        /// </summary>
        /// <param name="image"></param>
        /// <param name="Dest">location on HS html/images </param>
        /// <param name="Height">If want to resize</param>
        /// <param name="addPluginName">Prepend plugin name, i.e. html/images/MyPlugin/image.jpg </param>
        /// <returns></returns>
        public string WriteHTMLImage(Image image, string Dest, double Height = 0, bool addPluginName = true)
        {
            if (addPluginName)
                Dest = $"{PluginNameNoSpace}/{Dest}";

            if (Height > 0 && Height != image.Height)
            {
                Size size = new Size((int)((double)image.Width * (Height / (double)image.Height)), (int)Height);
                image = (Image)(new Bitmap(image, size));
            }

            if (HS.WriteHTMLImage(image, Dest, true))
                return $"images/{Dest}";

            return "";
        }


        #endregion Helpers


    }
}